var k1 = 1833, k2=1246;

var COMPONENTS_PER_TEXEL = 4;

// look for zero padding solution?
var result,
	p,
	max = 0,
	maxResult;

for(var i = COMPONENTS_PER_TEXEL; i < 1024*1024;i++){

	//var K = k1 * (k2 + i);
	var K = i;

	result = factorize(K);
	p = result[2];

	if(p >= max){
		max = p;
		maxResult = result;
	}

	//console.log(padNumber(K, 8) + ": "  + padNumber(p1) + ", " + padNumber(p2) + ", " + padNumber(p3) + ": " + padNumber(result[0]) + " x " + padNumber(result[1]));
}

console.log("max p: " + padNumber(max) + ": " + padNumber(maxResult[0]) + " x " + padNumber(maxResult[1]));

function padNumber(num, times){
	times = times || 5;

	var pad = " ".repeat(times);
	if(num == Infinity) num = "inf";

	return String(pad + num).slice( -1 * times);
}

function methodOne(K){

	var k = K / 4;

	var m = Math.sqrt(k);

	// factor one
	var N = Math.ceil(m);

	// factor two
	var M = Math.ceil(k / N);

	// padding required
	var p = (M * N * 4) - K;

	return [M, N, p];
}

function methodTwo(K){

	var m = Math.sqrt(K);

	// factor one
	var N = Math.ceil(m);

	// factor two
	var M = Math.ceil(K / N);

	// padding required
	var p = (M * N) - K;

	return [M, N, p];
}


/* Split a large number into the product of to smaller numbers, with as
   little padding as possible. Useful for putting a large vector into
   a texture.
   search for numbers slightly larger than K which are evenly divisible by
   numbers close to sqrt(K) * 4
 */
function factorize(K){

	// how many values greater than K to check, this sets the bound on p
	var m = Math.floor(Math.sqrt(K / COMPONENTS_PER_TEXEL));
	var K_p; // padded K
	var N, M, p;

	for(var i = 0; i < COMPONENTS_PER_TEXEL*m; i++){
		K_p = K + i;

		for(var j = 0; j < COMPONENTS_PER_TEXEL*Math.sqrt(m); j++){
			N = m + j

			// current padded length divisible by 4*N?
			if(K_p % (COMPONENTS_PER_TEXEL * N) === 0){
				M = K_p / (N * COMPONENTS_PER_TEXEL);

				p = (M * N * COMPONENTS_PER_TEXEL) - K;

				return [M, N, p];
			}
		}
	}

	return [0, 0, Infinity]; // we never get here
}

function printStuff(M, N, K){

	console.log("N:\t" + N);
	console.log("M:\t" + M);
	console.log("MxNx4:\t" + M * N * 4);
	console.log("p:\t" + p);

	console.log("K:\t" + K);
}
